/* AMX Mod script.
*
* (c) 2002, tcquest78
* This file is provided as is (no warranties).
*
* Provides help for admin commands with amx_help command
*/

#include <amxmod>

#define HELP_LIST_AMOUNT 10

public admin_help(id,level,cid){
	new arg1[8]
	new flags = get_user_flags(id)
	new start = read_argv(1,arg1,7) ? strtonum(arg1) : 1
	if (--start < 0) start = 0
	new clcmdsnum = get_concmdsnum(flags,id)
	if (start >= clcmdsnum) start = clcmdsnum - 1
	if (flags){
		new sflags[32]
		get_flags(flags,sflags,31)
		console_print(id,"Your access is: %s. You have %simmunity.^n",sflags, (flags&ADMIN_IMMUNITY)?"":"no " ) 
	}
	else
		console_print(id,"You are not logged as admin or user with privileges.^n")
	console_print(id,"----- AMX Help: Commands -----")
	new info[128], cmd[32], eflags
	new end = start + HELP_LIST_AMOUNT
	if (end > clcmdsnum) end = clcmdsnum
	for (new i = start; i < end; i++){
		get_concmd(i,cmd,31,eflags,info,127,flags,id)
		console_print(id,"%3d: %s %s",i+1,cmd,info)
	}
	if (end < clcmdsnum) {
		 console_print(id,"----- Entries %i - %i of %i -----",start+1,end,clcmdsnum)
		 console_print(id,"----- Use 'amx_help %i' for more -----",end+1)
	} else { 
		 console_print(id,"----- Entries %i - %i of %i -----",start+1,clcmdsnum,clcmdsnum)
		 console_print(id,"----- Use 'amx_help 1' for begin -----")
	}
	return PLUGIN_HANDLED 
}

public display_info(param[]){
	new id = param[0]
	if (id)
		client_print(id,print_chat,"* Type 'amx_help' in the console to see available commands")
	else
		server_print("Type 'amx_help' in the console to see available commands")
	new nextmap[32]
	get_cvar_string("amx_nextmap",nextmap,31)
	if (get_cvar_float("mp_timelimit")){
		new timeleft = get_timeleft()
		if (timeleft > 0){
			if (id)
				client_print(id,print_chat,"* Time remaining: %d:%02d min. The next map will be %s",
					timeleft / 60, timeleft % 60,nextmap)
			else
				server_print("Time remaining: %d:%02d min. The next map will be %s",
					timeleft / 60, timeleft % 60,nextmap)			
		}
	}
	else{
		if (id)
			client_print(id,print_chat,"* There is no time limit. The next map will be %s",nextmap)
		else
			server_print("There is no time limit. The next map will be %s",nextmap)
	}
}

public client_putinserver(id){
	if (!is_user_bot(id)){
		new param[3]
		param[0] = id
		set_task(15.0,"display_info",0,param,2)
	}
	return PLUGIN_CONTINUE
}

public plugin_init() {
	register_plugin("Admin Help","0.9.2","tcquest78") 
	register_concmd("amx_help","admin_help",0,"- displays this help")
	new param[2]
	param[0] = 0
	set_task(15.0,"display_info",0,param,1)
	return PLUGIN_CONTINUE
}